Compatibility text updated.
[gnutls.git] / maint.mk
blobff2fbbb382d755d58c1dcd5d8bd58d656aad9dcf
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
32 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
34 GIT = git
35 VC = $(GIT)
36 VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
38 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
40 # You can override this variable in cfg.mk to set your own regexp
41 # matching files to ignore.
42 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
44 # This is to preprocess robustly the output of $(VC_LIST), so that even
45 # when $(srcdir) is a pathological name like "....", the leading sed command
46 # removes only the intended prefix.
47 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
49 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50 # when $(srcdir) is not ".".
51 ifeq ($(srcdir),.)
52 _prepend_srcdir_prefix =
53 else
54 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55 endif
57 # In order to be able to consistently filter "."-relative names,
58 # (i.e., with no $(srcdir) prefix), this definition is careful to
59 # remove any $(srcdir) prefix, and to restore what it removes.
60 VC_LIST_EXCEPT = \
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
67 ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69 endif
71 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72 VERSION_REGEXP = $(subst .,\.,$(VERSION))
73 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
75 ifeq ($(VC),$(GIT))
76 this-vc-tag = v$(VERSION)
77 this-vc-tag-regexp = v$(VERSION_REGEXP)
78 else
79 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80 tag-this-version = $(subst .,_,$(VERSION))
81 this-vc-tag = $(tag-package)-$(tag-this-version)
82 this-vc-tag-regexp = $(this-vc-tag)
83 endif
84 my_distdir = $(PACKAGE)-$(VERSION)
86 # Old releases are stored here.
87 release_archive_dir ?= ../release
89 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90 # Use alpha.gnu.org for alpha and beta releases.
91 # Use ftp.gnu.org for stable releases.
92 gnu_ftp_host-alpha = alpha.gnu.org
93 gnu_ftp_host-beta = alpha.gnu.org
94 gnu_ftp_host-stable = ftp.gnu.org
95 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
97 ifeq ($(gnu_rel_host),ftp.gnu.org)
98 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99 else
100 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101 endif
103 # Override this in cfg.mk if you are using a different format in your
104 # NEWS file.
105 today = $(shell date +%Y-%m-%d)
107 # Select which lines of NEWS are searched for $(news-check-regexp).
108 # This is a sed line number spec. The default says that we search
109 # lines 1..10 of NEWS for $(news-check-regexp).
110 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
111 news-check-lines-spec ?= 1,10
112 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
114 # Prevent programs like 'sort' from considering distinct strings to be equal.
115 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
116 export LC_ALL = C
118 ## --------------- ##
119 ## Sanity checks. ##
120 ## --------------- ##
122 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
124 # Collect the names of rules starting with `sc_'.
125 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
126 $(srcdir)/$(ME) $(_cfg_mk)))
127 .PHONY: $(syntax-check-rules)
129 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
130 local-checks-available += $(syntax-check-rules)
131 else
132 local-checks-available += no-vc-detected
133 no-vc-detected:
134 @echo "No version control files detected; skipping syntax check"
135 endif
136 .PHONY: $(local-checks-available)
138 # Arrange to print the name of each syntax-checking rule just before running it.
139 $(syntax-check-rules): %: %.m
140 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
141 .PHONY: $(sc_m_rules_)
142 $(sc_m_rules_):
143 @echo $(patsubst sc_%.m, %, $@)
144 @date +%s.%N > .sc-start-$(basename $@)
146 # Compute and print the elapsed time for each syntax-check rule.
147 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
148 .PHONY: $(sc_z_rules_)
149 $(sc_z_rules_): %.z: %
150 @end=$$(date +%s.%N); \
151 start=$$(cat .sc-start-$*); \
152 rm -f .sc-start-$*; \
153 awk -v s=$$start -v e=$$end \
154 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
156 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
157 # that computes and prints elapsed time.
158 local-check := \
159 $(patsubst sc_%, sc_%.z, \
160 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
162 syntax-check: $(local-check)
164 # _sc_search_regexp
166 # This macro searches for a given construct in the selected files and
167 # then takes some action.
169 # Parameters (shell variables):
171 # prohibit | require
173 # Regular expression (ERE) denoting either a forbidden construct
174 # or a required construct. Those arguments are exclusive.
176 # in_vc_files | in_files
178 # grep-E-style regexp denoting the files to check. If no files
179 # are specified the default are all the files that are under
180 # version control.
182 # containing | non_containing
184 # Select the files (non) containing strings matching this regexp.
185 # If both arguments are specified then CONTAINING takes
186 # precedence.
188 # with_grep_options
190 # Extra options for grep.
192 # ignore_case
194 # Ignore case.
196 # halt
198 # Message to display before to halting execution.
200 # By default, _sc_search_regexp does not ignore case.
201 export ignore_case =
202 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
204 define _sc_say_and_exit
205 dummy=; : so we do not need a semicolon before each use; \
206 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
207 endef
209 # _sc_search_regexp used to be named _prohibit_regexp. However,
210 # upgrading to the new definition and leaving the old name undefined
211 # would usually convert each custom rule using $(_prohibit_regexp)
212 # (usually defined in cfg.mk) into a no-op. This definition ensures
213 # that people know right away if they're still using the old name.
214 # FIXME: remove in 2012.
215 _prohibit_regexp = \
216 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
218 define _sc_search_regexp
219 dummy=; : so we do not need a semicolon before each use; \
221 : Check arguments; \
222 test -n "$$prohibit" && test -n "$$require" \
223 && { msg='Cannot specify both prohibit and require' \
224 $(_sc_say_and_exit) } || :; \
225 test -z "$$prohibit" && test -z "$$require" \
226 && { msg='Should specify either prohibit or require' \
227 $(_sc_say_and_exit) } || :; \
228 test -n "$$in_vc_files" && test -n "$$in_files" \
229 && { msg='Cannot specify both in_vc_files and in_files' \
230 $(_sc_say_and_exit) } || :; \
231 test "x$$halt" != x \
232 || { msg='halt not defined' $(_sc_say_and_exit) }; \
234 : Filter by file name; \
235 if test -n "$$in_files"; then \
236 files=$$(find $(srcdir) | grep -E "$$in_files"); \
237 else \
238 files=$$($(VC_LIST_EXCEPT)); \
239 if test -n "$$in_vc_files"; then \
240 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
241 fi; \
242 fi; \
244 : Filter by content; \
245 test -n "$$files" && test -n "$$containing" \
246 && { files=$$(grep -l "$$containing" $$files); } || :; \
247 test -n "$$files" && test -n "$$non_containing" \
248 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
250 : Check for the construct; \
251 if test -n "$$files"; then \
252 if test -n "$$prohibit"; then \
253 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
254 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
255 else \
256 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
257 | grep . \
258 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
259 fi \
260 else :; \
261 fi || :;
262 endef
264 sc_avoid_if_before_free:
265 @$(build_aux)/useless-if-before-free \
266 $(useless_free_options) \
267 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
268 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
269 exit 1; } || :
271 sc_cast_of_argument_to_free:
272 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
273 $(_sc_search_regexp)
275 sc_cast_of_x_alloc_return_value:
276 @prohibit='\*\) *x(m|c|re)alloc\>' \
277 halt='don'\''t cast x*alloc return value' \
278 $(_sc_search_regexp)
280 sc_cast_of_alloca_return_value:
281 @prohibit='\*\) *alloca\>' \
282 halt='don'\''t cast alloca return value' \
283 $(_sc_search_regexp)
285 sc_space_tab:
286 @prohibit='[ ] ' \
287 halt='found SPACE-TAB sequence; remove the SPACE' \
288 $(_sc_search_regexp)
290 # Don't use *scanf or the old ato* functions in `real' code.
291 # They provide no error checking mechanism.
292 # Instead, use strto* functions.
293 sc_prohibit_atoi_atof:
294 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
295 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
296 $(_sc_search_regexp)
298 # Use STREQ rather than comparing strcmp == 0, or != 0.
299 sc_prohibit_strcmp:
300 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
301 $$($(VC_LIST_EXCEPT)) \
302 | grep -vE ':# *define STRN?EQ\(' && \
303 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
304 1>&2; exit 1; } || :
306 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
307 # Convert all uses automatically, via these two commands:
308 # git grep -l '\<exit *(1)' \
309 # | grep -vEf .x-sc_prohibit_magic_number_exit \
310 # | xargs --no-run-if-empty \
311 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
312 # git grep -l '\<exit *(0)' \
313 # | grep -vEf .x-sc_prohibit_magic_number_exit \
314 # | xargs --no-run-if-empty \
315 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
316 sc_prohibit_magic_number_exit:
317 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
318 halt='use EXIT_* values rather than magic number' \
319 $(_sc_search_regexp)
321 # Using EXIT_SUCCESS as the first argument to error is misleading,
322 # since when that parameter is 0, error does not exit. Use `0' instead.
323 sc_error_exit_success:
324 @prohibit='error *\(EXIT_SUCCESS,' \
325 in_vc_files='\.[chly]$$' \
326 halt='found error (EXIT_SUCCESS' \
327 $(_sc_search_regexp)
329 # `FATAL:' should be fully upper-cased in error messages
330 # `WARNING:' should be fully upper-cased, or fully lower-cased
331 sc_error_message_warn_fatal:
332 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
333 | grep -E '"Warning|"Fatal|"fatal' && \
334 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
335 exit 1; } || :
337 # Error messages should not start with a capital letter
338 sc_error_message_uppercase:
339 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
340 | grep -E '"[A-Z]' \
341 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
342 { echo '$(ME): found capitalized error message' 1>&2; \
343 exit 1; } || :
345 # Error messages should not end with a period
346 sc_error_message_period:
347 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
348 | grep -E '[^."]\."' && \
349 { echo '$(ME): found error message ending in period' 1>&2; \
350 exit 1; } || :
352 sc_file_system:
353 @prohibit=file''system \
354 ignore_case=1 \
355 halt='found use of "file''system"; spell it "file system"' \
356 $(_sc_search_regexp)
358 # Don't use cpp tests of this symbol. All code assumes config.h is included.
359 sc_prohibit_have_config_h:
360 @prohibit='^# *if.*HAVE''_CONFIG_H' \
361 halt='found use of HAVE''_CONFIG_H; remove' \
362 $(_sc_search_regexp)
364 # Nearly all .c files must include <config.h>. However, we also permit this
365 # via inclusion of a package-specific header, if cfg.mk specified one.
366 # config_h_header must be suitable for grep -E.
367 config_h_header ?= <config\.h>
368 sc_require_config_h:
369 @require='^# *include $(config_h_header)' \
370 in_vc_files='\.c$$' \
371 halt='the above files do not include <config.h>' \
372 $(_sc_search_regexp)
374 # You must include <config.h> before including any other header file.
375 # This can possibly be via a package-specific header, if given by cfg.mk.
376 sc_require_config_h_first:
377 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
378 fail=0; \
379 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
380 grep '^# *include\>' $$i | sed 1q \
381 | grep -E '^# *include $(config_h_header)' > /dev/null \
382 || { echo $$i; fail=1; }; \
383 done; \
384 test $$fail = 1 && \
385 { echo '$(ME): the above files include some other header' \
386 'before <config.h>' 1>&2; exit 1; } || :; \
387 else :; \
390 sc_prohibit_HAVE_MBRTOWC:
391 @prohibit='\bHAVE_MBRTOWC\b' \
392 halt="do not use $$prohibit; it is always defined" \
393 $(_sc_search_regexp)
395 # To use this "command" macro, you must first define two shell variables:
396 # h: the header, enclosed in <> or ""
397 # re: a regular expression that matches IFF something provided by $h is used.
398 define _sc_header_without_use
399 dummy=; : so we do not need a semicolon before each use; \
400 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
401 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
402 files=$$(grep -l '^# *include '"$$h_esc" \
403 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
404 grep -LE "$$re" $$files | grep . && \
405 { echo "$(ME): the above files include $$h but don't use it" \
406 1>&2; exit 1; } || :; \
407 else :; \
409 endef
411 # Prohibit the inclusion of assert.h without an actual use of assert.
412 sc_prohibit_assert_without_use:
413 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
415 # Prohibit the inclusion of close-stream.h without an actual use.
416 sc_prohibit_close_stream_without_use:
417 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
419 # Prohibit the inclusion of getopt.h without an actual use.
420 sc_prohibit_getopt_without_use:
421 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
423 # Don't include quotearg.h unless you use one of its functions.
424 sc_prohibit_quotearg_without_use:
425 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
427 # Don't include quote.h unless you use one of its functions.
428 sc_prohibit_quote_without_use:
429 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
431 # Don't include this header unless you use one of its functions.
432 sc_prohibit_long_options_without_use:
433 @h='"long-options.h"' re='\<parse_long_options *\(' \
434 $(_sc_header_without_use)
436 # Don't include this header unless you use one of its functions.
437 sc_prohibit_inttostr_without_use:
438 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
439 $(_sc_header_without_use)
441 # Don't include this header unless you use one of its functions.
442 sc_prohibit_ignore_value_without_use:
443 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
444 $(_sc_header_without_use)
446 # Don't include this header unless you use one of its functions.
447 sc_prohibit_error_without_use:
448 @h='"error.h"' \
449 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
450 $(_sc_header_without_use)
452 # Don't include xalloc.h unless you use one of its functions.
453 # Consider these symbols:
454 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
455 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
456 # Divide into two sets on case, and filter each through this:
457 # | sort | perl -MRegexp::Assemble -le \
458 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
459 # Note this was produced by the above:
460 # _xa1 = \
461 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
462 # But we can do better, in at least two ways:
463 # 1) take advantage of two "dup"-suffixed strings:
464 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
465 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
466 # "char|[cmz]"
467 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
468 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
469 _xa2 = X([CZ]|N?M)ALLOC
470 sc_prohibit_xalloc_without_use:
471 @h='"xalloc.h"' \
472 re='\<($(_xa1)|$(_xa2)) *\('\
473 $(_sc_header_without_use)
475 # Extract function names:
476 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
477 _hash_re = \
478 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
479 _hash_fn = \<($(_hash_re)) *\(
480 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
481 sc_prohibit_hash_without_use:
482 @h='"hash.h"' \
483 re='$(_hash_fn)|$(_hash_struct)'\
484 $(_sc_header_without_use)
486 sc_prohibit_hash_pjw_without_use:
487 @h='"hash-pjw.h"' \
488 re='\<hash_pjw *\(' \
489 $(_sc_header_without_use)
491 sc_prohibit_safe_read_without_use:
492 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
493 $(_sc_header_without_use)
495 sc_prohibit_argmatch_without_use:
496 @h='"argmatch.h"' \
497 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
498 $(_sc_header_without_use)
500 sc_prohibit_canonicalize_without_use:
501 @h='"canonicalize.h"' \
502 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
503 $(_sc_header_without_use)
505 sc_prohibit_root_dev_ino_without_use:
506 @h='"root-dev-ino.h"' \
507 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
508 $(_sc_header_without_use)
510 sc_prohibit_openat_without_use:
511 @h='"openat.h"' \
512 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
513 $(_sc_header_without_use)
515 # Prohibit the inclusion of c-ctype.h without an actual use.
516 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
517 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
518 sc_prohibit_c_ctype_without_use:
519 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
520 $(_sc_header_without_use)
522 _empty =
523 _sp = $(_empty) $(_empty)
524 # The following list was generated by running:
525 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
526 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
527 _sig_functions = \
528 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
529 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
530 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
531 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
532 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
533 # The following were extracted from "man signal.h" manually.
534 _sig_types_and_consts = \
535 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
536 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
537 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
538 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
539 sigstack sigval stack_t ucontext_t
540 # generated via this:
541 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
542 _sig_names = \
543 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
544 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
545 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
546 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
547 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
548 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
549 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
550 SIGXCPU SIGXFSZ
551 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
553 # Prohibit the inclusion of signal.h without an actual use.
554 sc_prohibit_signal_without_use:
555 @h='<signal.h>' \
556 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
557 $(_sc_header_without_use)
559 # Prohibit the inclusion of strings.h without a sensible use.
560 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
561 sc_prohibit_strings_without_use:
562 @h='<strings.h>' \
563 re='\<(strn?casecmp|ffs(ll)?)\>' \
564 $(_sc_header_without_use)
566 # Get the list of symbol names with this:
567 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
568 _intprops_names = \
569 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
570 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
571 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
572 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
573 # Prohibit the inclusion of intprops.h without an actual use.
574 sc_prohibit_intprops_without_use:
575 @h='"intprops.h"' \
576 re='\<($(_intprops_syms_re)) *\(' \
577 $(_sc_header_without_use)
579 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
580 # Prohibit the inclusion of stddef.h without an actual use.
581 sc_prohibit_stddef_without_use:
582 @h='<stddef.h>' \
583 re='\<($(_stddef_syms_re)) *\(' \
584 $(_sc_header_without_use)
586 sc_obsolete_symbols:
587 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
588 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
589 $(_sc_search_regexp)
591 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
593 # Each nonempty ChangeLog line must start with a year number, or a TAB.
594 sc_changelog:
595 @prohibit='^[^12 ]' \
596 in_vc_files='^ChangeLog$$' \
597 halt='found unexpected prefix in a ChangeLog' \
598 $(_sc_search_regexp)
600 # Ensure that each .c file containing a "main" function also
601 # calls set_program_name.
602 sc_program_name:
603 @require='set_program_name *\(m?argv\[0\]\);' \
604 in_vc_files='\.c$$' \
605 containing='\<main *(' \
606 halt='the above files do not call set_program_name' \
607 $(_sc_search_regexp)
609 # Ensure that each .c file containing a "main" function also
610 # calls bindtextdomain.
611 sc_bindtextdomain:
612 @require='bindtextdomain *\(' \
613 in_vc_files='\.c$$' \
614 containing='\<main *(' \
615 halt='the above files do not call bindtextdomain' \
616 $(_sc_search_regexp)
618 # Require that the final line of each test-lib.sh-using test be this one:
619 # Exit $fail
620 # Note: this test requires GNU grep's --label= option.
621 Exit_witness_file ?= tests/test-lib.sh
622 Exit_base := $(notdir $(Exit_witness_file))
623 sc_require_test_exit_idiom:
624 @if test -f $(srcdir)/$(Exit_witness_file); then \
625 die=0; \
626 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
627 $$($(VC_LIST) tests)); do \
628 tail -n1 $$i | grep '^Exit .' > /dev/null \
629 && : || { die=1; echo $$i; } \
630 done; \
631 test $$die = 1 && \
632 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
633 echo 1>&2 'Exit something'; \
634 exit 1; } || :; \
637 sc_the_the:
638 @prohibit='\<the ''the\>' \
639 ignore_case=1 \
640 halt='found use of "the ''the";' \
641 $(_sc_search_regexp)
643 sc_trailing_blank:
644 @prohibit='[ ]$$' \
645 halt='found trailing blank(s)' \
646 $(_sc_search_regexp)
648 # Match lines like the following, but where there is only one space
649 # between the options and the description:
650 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
651 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
652 sc_two_space_separator_in_usage:
653 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
654 halt='help2man requires at least two spaces between an option and its description'\
655 $(_sc_search_regexp)
657 # Look for diagnostics that aren't marked for translation.
658 # This won't find any for which error's format string is on a separate line.
659 sc_unmarked_diagnostics:
660 @grep -nE \
661 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
662 | grep -v '_''(' && \
663 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
664 exit 1; } || :
666 # Avoid useless parentheses like those in this example:
667 # #if defined (SYMBOL) || defined (SYM2)
668 sc_useless_cpp_parens:
669 @prohibit='^# *if .*defined *\(' \
670 halt='found useless parentheses in cpp directive' \
671 $(_sc_search_regexp)
673 # List headers for which HAVE_HEADER_H is always true, assuming you are
674 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
675 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
676 # requires the gnulib module that guarantees the usability of that header.
677 gl_assured_headers_ = \
678 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
680 # Convert the list of names to upper case, and replace each space with "|".
681 az_ = abcdefghijklmnopqrstuvwxyz
682 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
683 gl_header_upper_case_or_ = \
684 $$($(gl_assured_headers_) \
685 | tr $(az_)/.- $(AZ_)___ \
686 | tr -s ' ' '|' \
688 sc_prohibit_always_true_header_tests:
689 @or=$(gl_header_upper_case_or_); \
690 re="HAVE_($$or)_H"; \
691 prohibit='\<'"$$re"'\>' \
692 halt=$$(printf '%s\n' \
693 'do not test the above HAVE_<header>_H symbol(s);' \
694 ' with the corresponding gnulib module, they are always true') \
695 $(_sc_search_regexp)
697 # ==================================================================
698 gl_other_headers_ ?= \
699 intprops.h \
700 openat.h \
701 stat-macros.h
703 # Perl -lne code to extract "significant" cpp-defined symbols from a
704 # gnulib header file, eliminating a few common false-positives.
705 gl_extract_significant_defines_ = \
706 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
707 && $$2 !~ /(?:rpl_|_used_without_)/\
708 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
709 and print $$1
711 # Create a list of regular expressions matching the names
712 # of macros that are guaranteed to be defined by parts of gnulib.
713 define def_sym_regex
714 gen_h=$(gl_generated_headers_); \
715 (cd $(gnulib_dir)/lib; \
716 for f in *.in.h $(gl_other_headers_); do \
717 perl -lne '$(gl_extract_significant_defines_)' $$f; \
718 done; \
719 ) | sort -u \
720 | grep -Ev '^ATTRIBUTE_NORETURN' \
721 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
722 endef
724 # Don't define macros that we already get from gnulib header files.
725 sc_prohibit_always-defined_macros:
726 @if test -d $(gnulib_dir); then \
727 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
728 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
729 esac; \
730 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
731 && { echo '$(ME): define the above via some gnulib .h file' \
732 1>&2; exit 1; } || :; \
734 # ==================================================================
736 # Prohibit checked in backup files.
737 sc_prohibit_backup_files:
738 @$(VC_LIST) | grep '~$$' && \
739 { echo '$(ME): found version controlled backup file' 1>&2; \
740 exit 1; } || :
742 # Require the latest GPL.
743 sc_GPL_version:
744 @prohibit='either ''version [^3]' \
745 halt='GPL vN, N!=3' \
746 $(_sc_search_regexp)
748 # Require the latest GFDL. Two regexp, since some .texi files end up
749 # line wrapping between 'Free Documentation License,' and 'Version'.
750 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
751 sc_GFDL_version:
752 @prohibit='$(_GFDL_regexp)' \
753 halt='GFDL vN, N!=3' \
754 $(_sc_search_regexp)
756 # Don't use Texinfo's @acronym{}.
757 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
758 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
759 sc_texinfo_acronym:
760 @prohibit='@acronym\{' \
761 in_vc_files='$(texinfo_suffix_re_)' \
762 halt='found use of Texinfo @acronym{}' \
763 $(_sc_search_regexp)
765 cvs_keywords = \
766 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
768 sc_prohibit_cvs_keyword:
769 @prohibit='\$$($(cvs_keywords))\$$' \
770 halt='do not use CVS keyword expansion' \
771 $(_sc_search_regexp)
773 # This Perl code is slightly obfuscated. Not only is each "$" doubled
774 # because it's in a Makefile, but the $$c's are comments; we cannot
775 # use "#" due to the way the script ends up concatenated onto one line.
776 # It would be much more concise, and would produce better output (including
777 # counts) if written as:
778 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
779 # but that would be far less efficient, reading the entire contents
780 # of each file, rather than just the last two bytes of each.
782 # This is a perl script that is expected to be the single-quoted argument
783 # to a command-line "-le". The remaining arguments are file names.
784 # Print the name of each file that ends in two or more newline bytes.
785 # Exit nonzero if at least one such file is found, otherwise, exit 0.
786 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
788 # Use this if you want to remove trailing empty lines from selected files:
789 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
791 detect_empty_lines_at_EOF_ = \
792 foreach my $$f (@ARGV) \
794 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
795 my $$p = sysseek (F, -2, 2); \
796 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
797 my $$last_two_bytes; \
798 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
799 close F; \
800 $$c = "ignore read failure"; \
801 $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \
803 END { exit defined $$fail }
804 sc_prohibit_empty_lines_at_EOF:
805 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
806 || { echo '$(ME): the above files end with empty line(s)' \
807 1>&2; exit 1; } || :; \
809 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
810 # This is a bit of a kludge, since it prevents use of the string
811 # even in comments, but for now it does the job with no false positives.
812 sc_prohibit_stat_st_blocks:
813 @prohibit='[.>]st_blocks' \
814 halt='do not use st_blocks; use ST_NBLOCKS' \
815 $(_sc_search_regexp)
817 # Make sure we don't define any S_IS* macros in src/*.c files.
818 # They're already defined via gnulib's sys/stat.h replacement.
819 sc_prohibit_S_IS_definition:
820 @prohibit='^ *# *define *S_IS' \
821 halt='do not define S_IS* macros; include <sys/stat.h>' \
822 $(_sc_search_regexp)
824 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
825 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
826 # Using test's -a and -o operators is not portable.
827 # We prefer test over [, since the latter is spelled [[ in configure.ac.
828 sc_prohibit_test_minus_ao:
829 @prohibit='(\<test| \[+) .+ -[ao] ' \
830 halt='$(_ptm1); $(_ptm2)' \
831 $(_sc_search_regexp)
833 # Avoid a test bashism.
834 sc_prohibit_test_double_equal:
835 @prohibit='(\<test| \[+) .+ == ' \
836 containing='#! */bin/[a-z]*sh' \
837 halt='use "test x = x", not "test x =''= x"' \
838 $(_sc_search_regexp)
840 # Each program that uses proper_name_utf8 must link with one of the
841 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
842 # The perl -0777 invocation below extracts the possibly-multi-line
843 # definition of LDADD from the appropriate Makefile.am and exits 0
844 # when it contains "ICONV".
845 sc_proper_name_utf8_requires_ICONV:
846 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
847 if test "x$$progs" != x; then \
848 fail=0; \
849 for p in $$progs; do \
850 dir=$$(dirname "$$p"); \
851 perl -0777 \
852 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
853 $$dir/Makefile.am && continue; \
854 base=$$(basename "$$p" .c); \
855 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
856 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
857 done; \
858 test $$fail = 1 && \
859 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
860 exit 1; } || :; \
863 # Warn about "c0nst struct Foo const foo[]",
864 # but not about "char const *const foo" or "#define const const".
865 sc_redundant_const:
866 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
867 halt='redundant "const" in declarations' \
868 $(_sc_search_regexp)
870 sc_const_long_option:
871 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
872 | grep -Ev 'const struct option|struct option const' && { \
873 echo 1>&2 '$(ME): add "const" to the above declarations'; \
874 exit 1; } || :
876 NEWS_hash = \
877 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
878 $(srcdir)/NEWS \
879 | perl -0777 -pe \
880 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
881 | md5sum - \
882 | sed 's/ .*//')
884 # Ensure that we don't accidentally insert an entry into an old NEWS block.
885 sc_immutable_NEWS:
886 @if test -f $(srcdir)/NEWS; then \
887 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
888 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
891 # Update the hash stored above. Do this after each release and
892 # for any corrections to old entries.
893 update-NEWS-hash: NEWS
894 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
895 $(srcdir)/cfg.mk
897 # Ensure that we use only the standard $(VAR) notation,
898 # not @...@ in Makefile.am, now that we can rely on automake
899 # to emit a definition for each substituted variable.
900 # We use perl rather than "grep -nE ..." to exempt a single
901 # use of an @...@-delimited variable name in src/Makefile.am.
902 # Allow the package to add exceptions via a hook in cfg.mk;
903 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
904 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
905 _makefile_at_at_check_exceptions ?=
906 sc_makefile_at_at_check:
907 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
908 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
909 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
910 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
912 news-check: NEWS
913 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
914 | grep -E $(news-check-regexp) >/dev/null; then \
915 :; \
916 else \
917 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
918 exit 1; \
921 sc_makefile_TAB_only_indentation:
922 @prohibit='^ [ ]{8}' \
923 in_vc_files='akefile|\.mk$$' \
924 halt='found TAB-8-space indentation' \
925 $(_sc_search_regexp)
927 sc_m4_quote_check:
928 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
929 in_vc_files='(^configure\.ac|\.m4)$$' \
930 halt='quote the first arg to AC_DEF*' \
931 $(_sc_search_regexp)
933 fix_po_file_diag = \
934 'you have changed the set of files with translatable diagnostics;\n\
935 apply the above patch\n'
937 # Verify that all source files using _() are listed in po/POTFILES.in.
938 po_file = po/POTFILES.in
939 sc_po_check:
940 @if test -f $(po_file); then \
941 grep -E -v '^(#|$$)' $(po_file) \
942 | grep -v '^src/false\.c$$' | sort > $@-1; \
943 files=; \
944 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
945 test -r $$file || continue; \
946 case $$file in \
947 *.m4|*.mk) continue ;; \
948 *.?|*.??) ;; \
949 *) continue;; \
950 esac; \
951 case $$file in \
952 *.[ch]) \
953 base=`expr " $$file" : ' \(.*\)\..'`; \
954 { test -f $$base.l || test -f $$base.y; } && continue;; \
955 esac; \
956 files="$$files $$file"; \
957 done; \
958 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
959 | sort -u > $@-2; \
960 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
961 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
962 rm -f $@-1 $@-2; \
965 # Sometimes it is useful to change the PATH environment variable
966 # in Makefiles. When doing so, it's better not to use the Unix-centric
967 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
968 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
969 sc_makefile_path_separator_check:
970 @prohibit='PATH[=].*:' \
971 in_vc_files='akefile|\.mk$$' \
972 halt=$(msg) \
973 $(_sc_search_regexp)
975 # Check that `make alpha' will not fail at the end of the process.
976 writable-files:
977 if test -d $(release_archive_dir); then :; else \
978 for file in $(distdir).tar.gz \
979 $(release_archive_dir)/$(distdir).tar.gz; do \
980 test -e $$file || continue; \
981 test -w $$file \
982 || { echo ERROR: $$file is not writable; fail=1; }; \
983 done; \
984 test "$$fail" && exit 1 || : ; \
987 v_etc_file = $(gnulib_dir)/lib/version-etc.c
988 sample-test = tests/sample-test
989 texi = doc/$(PACKAGE).texi
990 # Make sure that the copyright date in $(v_etc_file) is up to date.
991 # Do the same for the $(sample-test) and the main doc/.texi file.
992 sc_copyright_check:
993 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
994 in_files=$(v_etc_file) \
995 halt='out of date copyright in $(v_etc_file); update it' \
996 $(_sc_search_regexp)
997 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
998 in_vc_files=$(sample-test) \
999 halt='out of date copyright in $(sample-test); update it' \
1000 $(_sc_search_regexp)
1001 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1002 in_vc_files=$(texi) \
1003 halt='out of date copyright in $(texi); update it' \
1004 $(_sc_search_regexp)
1006 # If tests/help-version exists and seems to be new enough, assume that its
1007 # use of init.sh and path_prepend_ is correct, and ensure that every other
1008 # use of init.sh is identical.
1009 # This is useful because help-version cross-checks prog --version
1010 # with $(VERSION), which verifies that its path_prepend_ invocation
1011 # sets PATH correctly. This is an inexpensive way to ensure that
1012 # the other init.sh-using tests also get it right.
1013 _hv_file ?= $(srcdir)/tests/help-version
1014 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1015 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1016 sc_cross_check_PATH_usage_in_tests:
1017 @if test -f $(_hv_file); then \
1018 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1019 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1020 exit 0; }; \
1021 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1022 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1023 exit 1; }; \
1024 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1025 grep -LFx "$$good" \
1026 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1027 | grep . && \
1028 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1029 1>&2; exit 1; } || :; \
1032 # #if HAVE_... will evaluate to false for any non numeric string.
1033 # That would be flagged by using -Wundef, however gnulib currently
1034 # tests many undefined macros, and so we can't enable that option.
1035 # So at least preclude common boolean strings as macro values.
1036 sc_Wundef_boolean:
1037 @prohibit='^#define.*(yes|no|true|false)$$' \
1038 in_files='$(CONFIG_INCLUDE)' \
1039 halt='Use 0 or 1 for macro values' \
1040 $(_sc_search_regexp)
1042 sc_vulnerable_makefile_CVE-2009-4029:
1043 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1044 in_files=$$(find $(srcdir) -name Makefile.in) \
1045 halt=$$(printf '%s\n' \
1046 'the above files are vulnerable; beware of running' \
1047 ' "make dist*" rules, and upgrade to fixed automake' \
1048 ' see http://bugzilla.redhat.com/542609 for details') \
1049 $(_sc_search_regexp)
1051 vc-diff-check:
1052 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1053 if test -s vc-diffs; then \
1054 cat vc-diffs; \
1055 echo "Some files are locally modified:" 1>&2; \
1056 exit 1; \
1057 else \
1058 rm vc-diffs; \
1061 rel-files = $(DIST_ARCHIVES)
1063 gnulib_dir ?= $(srcdir)/gnulib
1064 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1065 bootstrap-tools ?= autoconf,automake,gnulib
1067 # If it's not already specified, derive the GPG key ID from
1068 # the signed tag we've just applied to mark this release.
1069 gpg_key_ID ?= \
1070 $$(git cat-file tag v$(VERSION) > .ann-sig \
1071 && gpgv .ann-sig - < /dev/null 2>&1 \
1072 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1074 translation_project_ ?= coordinator@translationproject.org
1075 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1076 announcement_mail_headers_ ?= \
1077 To: info-gnu@gnu.org \
1078 Cc: $(announcement_Cc_) \
1079 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1081 announcement: NEWS ChangeLog $(rel-files)
1082 @$(build_aux)/announce-gen \
1083 --mail-headers='$(announcement_mail_headers_)' \
1084 --release-type=$(RELEASE_TYPE) \
1085 --package=$(PACKAGE) \
1086 --prev=$(PREV_VERSION) \
1087 --curr=$(VERSION) \
1088 --gpg-key-id=$(gpg_key_ID) \
1089 --news=$(srcdir)/NEWS \
1090 --bootstrap-tools=$(bootstrap-tools) \
1091 --gnulib-version=$(gnulib-version) \
1092 --no-print-checksums \
1093 $(addprefix --url-dir=, $(url_dir_list))
1095 ## ---------------- ##
1096 ## Updating files. ##
1097 ## ---------------- ##
1099 ftp-gnu = ftp://ftp.gnu.org/gnu
1100 www-gnu = http://www.gnu.org
1102 upload_dest_dir_ ?= $(PACKAGE)
1103 emit_upload_commands:
1104 @echo =====================================
1105 @echo =====================================
1106 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
1107 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1108 @echo " $(rel-files)"
1109 @echo '# send the ~/announce-$(my_distdir) e-mail'
1110 @echo =====================================
1111 @echo =====================================
1113 define emit-commit-log
1114 printf '%s\n' 'post-release administrivia' '' \
1115 '* NEWS: Add header line for next release.' \
1116 '* .prev-version: Record previous version.' \
1117 '* cfg.mk (old_NEWS_hash): Auto-update.'
1118 endef
1120 .PHONY: no-submodule-changes
1121 no-submodule-changes:
1122 if test -d $(srcdir)/.git; then \
1123 diff=$$(cd $(srcdir) && git submodule -q foreach \
1124 git diff-index --name-only HEAD) \
1125 || exit 1; \
1126 case $$diff in '') ;; \
1127 *) echo '$(ME): submodule files are locally modified:'; \
1128 echo "$$diff"; exit 1;; esac; \
1129 else \
1130 : ; \
1133 submodule-checks ?= no-submodule-changes public-submodule-commit
1135 # Ensure that each sub-module commit we're using is public.
1136 # Without this, it is too easy to tag and release code that
1137 # cannot be built from a fresh clone.
1138 .PHONY: public-submodule-commit
1139 public-submodule-commit:
1140 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1141 cd $(srcdir) && \
1142 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1143 = '$$(git merge-base origin $$sha1)' \
1144 || { echo '$(ME): found non-public submodule commit' >&2; \
1145 exit 1; }; \
1146 else \
1147 : ; \
1149 # This rule has a high enough utility/cost ratio that it should be a
1150 # dependent of "check" by default. However, some of us do occasionally
1151 # commit a temporary change that deliberately points to a non-public
1152 # submodule commit, and want to be able to use rules like "make check".
1153 # In that case, run e.g., "make check gl_public_submodule_commit="
1154 # to disable this test.
1155 gl_public_submodule_commit ?= public-submodule-commit
1156 check: $(gl_public_submodule_commit)
1158 .PHONY: alpha beta stable
1159 ALL_RECURSIVE_TARGETS += alpha beta stable
1160 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1161 test $@ = stable \
1162 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1163 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1164 || :
1165 $(MAKE) vc-diff-check
1166 $(MAKE) news-check
1167 $(MAKE) distcheck
1168 $(MAKE) dist XZ_OPT=-9ev
1169 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1170 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1172 # Override this in cfg.mk if you follow different procedures.
1173 release-prep-hook ?= release-prep
1175 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1176 .PHONY: release-prep
1177 release-prep:
1178 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1179 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1180 $(MAKE) -s announcement > ~/announce-$(my_distdir)
1181 if test -d $(release_archive_dir); then \
1182 ln $(rel-files) $(release_archive_dir); \
1183 chmod a-w $(rel-files); \
1185 echo $(VERSION) > $(prev_version_file)
1186 $(MAKE) update-NEWS-hash
1187 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1188 $(emit-commit-log) > .ci-msg
1189 $(VC) commit -F .ci-msg -a
1190 rm .ci-msg
1192 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1193 # if the default $(PACKAGE)-derived name doesn't apply.
1194 gendocs_options_ ?=
1196 .PHONY: web-manual
1197 web-manual:
1198 @test -z "$(manual_title)" \
1199 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1200 @cd '$(srcdir)/doc'; \
1201 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1202 -o '$(abs_builddir)/doc/manual' \
1203 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1204 "$(PACKAGE_NAME) - $(manual_title)"
1205 @echo " *** Upload the doc/manual directory to web-cvs."
1207 # Code Coverage
1209 init-coverage:
1210 $(MAKE) $(AM_MAKEFLAGS) clean
1211 lcov --directory . --zerocounters
1213 COVERAGE_CCOPTS ?= "-g --coverage"
1214 COVERAGE_OUT ?= doc/coverage
1216 build-coverage:
1217 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1218 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1219 mkdir -p $(COVERAGE_OUT)
1220 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1221 --capture
1223 gen-coverage:
1224 genhtml --output-directory $(COVERAGE_OUT) \
1225 $(COVERAGE_OUT)/$(PACKAGE).info \
1226 --highlight --frames --legend \
1227 --title "$(PACKAGE_NAME)"
1229 coverage: init-coverage build-coverage gen-coverage
1231 # Update gettext files.
1232 PACKAGE ?= $(shell basename $(PWD))
1233 PO_DOMAIN ?= $(PACKAGE)
1234 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1235 PODIR ?= po
1236 refresh-po:
1237 rm -f $(PODIR)/*.po && \
1238 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1239 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1240 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1241 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1242 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1244 # Running indent once is not idempotent, but running it twice is.
1245 INDENT_SOURCES ?= $(C_SOURCES)
1246 .PHONY: indent
1247 indent:
1248 indent $(INDENT_SOURCES)
1249 indent $(INDENT_SOURCES)
1251 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1252 # put the assignments in this variable.
1253 update-copyright-env ?=
1255 # Run this rule once per year (usually early in January)
1256 # to update all FSF copyright year lists in your project.
1257 # If you have an additional project-specific rule,
1258 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1259 # By default, exclude all variants of COPYING; you can also
1260 # add exemptions (such as ChangeLog..* for rotated change logs)
1261 # in the file .x-update-copyright.
1262 .PHONY: update-copyright
1263 update-copyright:
1264 grep -l -w Copyright \
1265 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1266 | $(update-copyright-env) xargs $(build_aux)/$@